/***************************************************************************
 *     copyright            : (C) 2005 by Roman Szymkowiak                 *  
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <windows.h>
#include <string.h>
#include "menu.h"
#include "kontrolki.h"
#include "Savedial.h"
#include "mojlabel.h"
#include "mojedit.h"
#include "kolor.h"
#include "drukuj.h"
#include "podglad.h"
#include "historia.h"
#include "opcje.h"


// MessageBox(0,"debug_1","komunikat",MB_OK);
//   wsprintf (buf, "i=%d",i) ;      

HINSTANCE zadanie;
HWND   hwndokno;


 HBRUSH   hBrushOkno =0;
 COLORREF Oknotlo;     //kolor ta okna
 HMENU menu; 
 LPSTR liniaPolecen;
 

LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);
void wybierzkolortla(HWND hwnd);
void zmienkolortla(COLORREF col);
void ustawPedzelTla(COLORREF col);

char szClassName[ ] = "sudoku9x9";

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,int nFunsterStil)

{
    HWND hwnd;               
    MSG messages;            
    WNDCLASSEX wincl;        
    HACCEL hakcer;
    
     zadanie = hInstance;
     liniaPolecen = lpszArgument;
     
     
    pobierzTloOpcje(); 
     
     
    
    wincl.hInstance = hInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      
    wincl.style = CS_DBLCLKS;                 
    wincl.cbSize = sizeof (WNDCLASSEX);
    wincl.hIcon = LoadIcon(hInstance, "proikona") ;
    wincl.hIconSm = LoadIcon(hInstance, "proikona") ;
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW) ;
    wincl.lpszMenuName = NULL;                 
    wincl.cbClsExtra = 0;                      
    wincl.cbWndExtra = 0;                      
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    if (!RegisterClassEx (&wincl))
        return 0;

    
    hwnd = CreateWindowEx (
           0,                   
           szClassName,         
           "Sudoku9x9 ver. 0.01",       
           WS_OVERLAPPEDWINDOW, 
           CW_USEDEFAULT,       
           CW_USEDEFAULT,       
           385,                 
           478,                 
           HWND_DESKTOP,        
           NULL,                
           hInstance,       
           NULL                 
           );

hwndokno = hwnd;

    ShowWindow (hwnd, nFunsterStil);
    menu = LoadMenu(hInstance, MAKEINTRESOURCE(ID_MENU));
    SetMenu(hwnd, menu);
//    EnableMenuItem(menu,IDM_PUSTE,MF_GRAYED);
    
    hakcer = LoadAccelerators(zadanie,"akcel1");
    
    while (GetMessage (&messages, NULL, 0, 0))
    {
      if(!TranslateAccelerator(hwnd,hakcer,&messages))
      {
        TranslateMessage(&messages);
        DispatchMessage(&messages);
      } 
    }

    return messages.wParam;
}



LRESULT CALLBACK WindowProcedure (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
 int i;
        HDC          hdc ;
       RECT         rect;
   PAINTSTRUCT  ps ;
   
    switch (message)                  /* handle the messages */
    {
   
    
    
           case WM_CREATE :
           
                Oknotlo = RGB(192,192,192);
                hBrushOkno = CreateSolidBrush(Oknotlo);
          SetClassLong (hwnd, GCL_HBRBACKGROUND,(LONG)hBrushOkno);

                tworz_kontrolki(hwnd,zadanie);
                PopFileInitialize (hwnd);
                podgladclassa(hwnd,zadanie);
                
                odczytajOpcje ();
                if (strlen(liniaPolecen) > 0)
                {
                  odczytajPlanszeLinia(liniaPolecen,hwnd);
                 }
                                 
                
                
  
                return 0 ;
         case WM_COMMAND :
                switch (LOWORD (wParam))
                    {
    			case IDM_FILENEW :
								  czysckontrolki();
								  break ;
                
     			case IDM_FILEOPEN :
								  FileOpenClick(hwnd);
								  break ;
								  
     			case IDM_FILESAVE :
								  FileSaveClick(hwnd);
								  break ;
     			case IDM_KOLOR :
								  wybierzkolor(hwnd);
								  break ;
     			case IDM_KOLORTLO :
								  wybierzkolortla(hwnd);
								  break ;
								  
     			case IDM_SPRAWDZ :
								  sprawdzplansze();
								  break ;
								  
								  
								  
								  
     			case IDM_HELPABOUT :
		MessageBox(hwnd,"Copyright (C) 2005, by Roman Szymkowiak\n\
Sudoku9x9 ver. 0.01 jest programem darmowym i nie wolno za niego pobiera opat.\n\
Autor nie ponosi odpowiedzialnoci za szkody wynike z uywania oprogramowania,\n\
zgodnie z GNU GENERAL PUBLIC LICENSE Version 2, June 1991\n\nSudoku gra logiczna.\nRozwizanie amigwki polega na umieszczeniu \
wszystkich cyfr od 1 do 9\n-w kadym wierszu\n-w kadej kolumnie\n-w kadym z dziewiciu mniejszych kwadratw \
\n\nWprowadzanie cyfr:\nw polu - prawy przycisk myszy\n\
pod polem - klawiatura\n\
\nBlokowanie pola - pod polem wprowadzi cudzysw\
\n                  (zapisa w formacie \"sud\", otworzy na nowo plansze)","opis",MB_OK);						  
								  break ;
                   
                    
                    case IDM_FILEEXIT :
                         SendMessage (hwnd, WM_CLOSE, 0, 0) ;
                         return 0 ;

                    case IDM_PRINT :
                     
                     if (!PopPrntPrintFile (zadanie, hwnd))
                        MessageBox(hwnd,"Bd drukowania","Uwaga",MB_OK);  
                                                           
                         return 0 ;
                         
                    case IDM_PODGLAD :
                           podglad(hwnd,zadanie);
                         return 0 ;
                         
                    case IDM_HZERUJ :
                           zerujHistoria();
                         return 0 ;
                    case IDM_HTYL :
                           DoTyluHistoria ();
                         return 0 ;
                    case IDM_HPRZOD :
                           DoPrzoduHistoria ();
                         return 0 ;
                    case IDM_HPODGLAD :
                           podgladHistoria (hwnd,zadanie);
                         return 0 ;
                          
                    case IDM_HZNACZNIK :
                           wstawZnacznikHistoria ();
                         return 0 ;
                          
                    case IDM_HSKOK :
                           skokHistoria (hwnd,zadanie);
                         return 0 ;
                         
                    case IDM_ZAPISZOPCJE :
                                zapiszOpcje ();
                         return 0 ;
                    
                     }
                 break ;
/*                 
		case WM_CTLCOLOREDIT:
	
		  {

			i = GetWindowLong ((HWND) lParam, GWL_ID) ;
			if ((i > 100) && (i < 182))
			 {
			  //SetTextColor ((HDC) wParam, GetSysColor (COLOR_WINDOWTEXT)) ;
			  SetBkColor ((HDC) wParam, Oknotlo);
			  //return (LRESULT) hBrush1 ;
			  return (LRESULT) hBrushOkno;
			 } 
           }      
           
            return DefWindowProc (hwnd, message, wParam, lParam);
    */   
              
          case WM_PAINT :
                hdc = BeginPaint (hwnd, &ps) ;
                 if (hBrushOkno != 0)
                 {
                  GetClientRect(hwnd,&rect);
                  FillRect(hdc,&rect,hBrushOkno);
                 }
                  EndPaint (hwnd, &ps) ;
               return 0 ;
          
         
           
           
           
        case WM_DESTROY:
            posprzataj();
           if (hBrushOkno != 0) DeleteObject(hBrushOkno);
            
            PostQuitMessage (0);       
            break;
        default:                     
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}
//-------------------
void wybierzkolortla(HWND hwnd)
{

 if (PopColorDlg (hwnd,Oknotlo))
 {
  zmienkolortla(cc.rgbResult);
 }

}
//--------------------------
void zmienkolortla(COLORREF col)
{
 int x,y;
  
  ustawPedzelTla(col);
  
  SetClassLong (hwndokno, GCL_HBRBACKGROUND,(LONG)hBrushOkno);
  zmienKolorEdit(Oknotlo) ;

/*  
    for (y=1 ; y < 10; y++){
     for (x=1 ; x<10; x++){
      SetClassLong (tabedit[x][y], GCL_HBRBACKGROUND,(LONG)hBrushOkno); 
      }
     }
*/
  InvalidateRect (hwndokno, NULL, TRUE) ;

}
//-------------------------------
void ustawPedzelTla(COLORREF col)
{

  Oknotlo = col;
  if (hBrushOkno != 0) DeleteObject(hBrushOkno);
  hBrushOkno = CreateSolidBrush(Oknotlo);

}

